﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ImageMove : MonoBehaviour {

    static public Vector3 defaultRotation = new Vector3(-90, 0, 0);
    static public Vector3 defaultPosition = new Vector3(0, 0, 0);
    static public Vector3 rotateRotation = new Vector3(-0, 0, 0);
    static public Vector3 rotatePosition = new Vector3(0, -15, 0);


    // Use this for initialization
    void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    private Vector3 screenPoint;
    private Vector3 offset;
    void OnMouseDown()
    {
        // カメラから見たオブジェクトの現在位置を画面位置座標に変換
        screenPoint = Camera.main.WorldToScreenPoint(this.transform.position);

        float x = Input.mousePosition.x;
        float y = Input.mousePosition.y;

        offset = transform.position - Camera.main.ScreenToWorldPoint(new Vector3(x, y, screenPoint.z));
    }

    void OnMouseDrag()
    {
        float x = Input.mousePosition.x;
        float y = Input.mousePosition.y;

        // ドラッグ時のマウスの位置をシーン上の3D空間の座標に変換
        Vector3 currentScreenPoint = new Vector3(x, y, screenPoint.z);

        Vector3 currentPosition = Camera.main.ScreenToWorldPoint(currentScreenPoint) + offset;

        var L = GameObject.Find("LSphere");
        var LComponent = L.GetComponent<MoveLimit>();
        if (LComponent.IsRender)
        {
            if (currentPosition.x >= this.transform.position.x )
            {
                return;
            }
        }
        var R = GameObject.Find("RSphere");
        var RComponent = R.GetComponent<MoveLimit>();
        if (RComponent.IsRender)
        {
            if (currentPosition.x <= this.transform.position.x)
            {
                return;
            }
        }

        this.transform.position = new Vector3(currentPosition.x, 0, 0);
    }


}
